models/ContactForm.php
<?php

namespace app\models;

use Yii;
use yii\base\Model;

/**
 * ContactForm is the model behind the contact form.
 */
class ContactForm extends Model
{
    public $name;
    public $email;
    public $subject;
    public $body;
    public $verifyCode;


    /**
     * @return array the validation rules.
     */
    public function rules()
    {
        return [
            // name, email, subject and body are required
            [['name', 'email', 'subject', 'body'], 'required'],
            // email has to be a valid email address
            ['email', 'email'],
            // verifyCode needs to be entered correctly
            ['verifyCode', 'captcha'],
        ];
    }

    /**
     * @return array customized attribute labels
     */
    public function attributeLabels()
    {
        return [
            'verifyCode' => 'Verification Code',
        ];
    }

    /**
     * Sends an email to the specified email address using the information collected by this model.
     * @param string $email the target email address
     * @return bool whether the model passes validation
     */
    public function contact($email)
    {
        if ($this->validate()) {
            Yii::$app->mailer->compose()
                ->setTo($email)
                ->setFrom([Yii::$app->params['senderEmail'] => Yii::$app->params['senderName']])
                ->setReplyTo([$this->email => $this->name])
                ->setSubject($this->subject)
                ->setTextBody($this->body)
                ->send();

            return true;
        }
        return false;
    }
}

models/LoginForm.php
<?php

namespace app\models;

use Yii;
use yii\base\Model;

/**
 * LoginForm is the model behind the login form.
 *
 * @property-read User|null $user
 *
 */
class LoginForm extends Model
{
    public $username;
    public $password;
    public $rememberMe = true;

    private $_user = false;


    /**
     * @return array the validation rules.
     */
    public function rules()
    {
        return [
            // username and password are both required
            [['username', 'password'], 'required'],
            // rememberMe must be a boolean value
            ['rememberMe', 'boolean'],
            // password is validated by validatePassword()
            ['password', 'validatePassword'],
        ];
    }

    /**
     * Validates the password.
     * This method serves as the inline validation for password.
     *
     * @param string $attribute the attribute currently being validated
     * @param array $params the additional name-value pairs given in the rule
     */
    public function validatePassword($attribute, $params)
    {
        if (!$this->hasErrors()) {
            $user = $this->getUser();

            if (!$user || !$user->validatePassword($this->password)) {
                $this->addError($attribute, 'Incorrect username or password.');
            }
        }
    }

    /**
     * Logs in a user using the provided username and password.
     * @return bool whether the user is logged in successfully
     */
    public function login()
    {
        if ($this->validate()) {
            return Yii::$app->user->login($this->getUser(), $this->rememberMe ? 3600*24*30 : 0);
        }
        return false;
    }

    /**
     * Finds user by [[username]]
     *
     * @return User|null
     */
    public function getUser()
    {
        if ($this->_user === false) {
            $this->_user = User::findByUsername($this->username);
        }

        return $this->_user;
    }
}

models/User.php
<?php

namespace app\models;

class User extends \yii\base\BaseObject implements \yii\web\IdentityInterface
{
    public $id;
    public $username;
    public $password;
    public $authKey;
    public $accessToken;

    private static $users = [
        '100' => [
            'id' => '100',
            'username' => 'admin',
            'password' => 'admin',
            'authKey' => 'test100key',
            'accessToken' => '100-token',
        ],
        '101' => [
            'id' => '101',
            'username' => 'demo',
            'password' => 'demo',
            'authKey' => 'test101key',
            'accessToken' => '101-token',
        ],
    ];


    /**
     * {@inheritdoc}
     */
    public static function findIdentity($id)
    {
        return isset(self::$users[$id]) ? new static(self::$users[$id]) : null;
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentityByAccessToken($token, $type = null)
    {
        foreach (self::$users as $user) {
            if ($user['accessToken'] === $token) {
                return new static($user);
            }
        }

        return null;
    }

    /**
     * Finds user by username
     *
     * @param string $username
     * @return static|null
     */
    public static function findByUsername($username)
    {
        foreach (self::$users as $user) {
            if (strcasecmp($user['username'], $username) === 0) {
                return new static($user);
            }
        }

        return null;
    }

    /**
     * {@inheritdoc}
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * {@inheritdoc}
     */
    public function getAuthKey()
    {
        return $this->authKey;
    }

    /**
     * {@inheritdoc}
     */
    public function validateAuthKey($authKey)
    {
        return $this->authKey === $authKey;
    }

    /**
     * Validates password
     *
     * @param string $password password to validate
     * @return bool if password provided is valid for current user
     */
    public function validatePassword($password)
    {
        return $this->password === $password;
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller {

    /**
     * {@inheritdoc}
     */
    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex() {
        return $this->render('index');
    }

    public function actionEjercicio1() {

        $alumnos = [
            'mario',
            'Denia',
            'Alalia',
            'ana'
        ];

        return $this->render('ejercicio1',
                        [
                            "alumnos" => $alumnos
        ]);
    }

    public function actionEjercicio2() {
        return $this->render('ejercicio2');
    }

    public function actionEjercicio3() {

        $numero = [1,2,3,4,5,6,7,8];
        
        return $this->render("ejercicio3",
                [
                    "datos"=>$numero
                ]);
         
    }

    public function actionEjercicio4($numero = 3) {

        $imagenes = [
            "111.jfif",
            "222.jfif",
            "333.jfif",
            "444.jfif",
        ];

        $datos = [
            ["nombre" => " pepe ", "apellidos" => " garcia perez ", "edad"=>45],
            ["nombre" => " juan ", "apellidos" => " Sanchez martinex ", "edad"=>24],
            ["nombre" => " Luisa ", "apellidos" => " Gonzalez diaz ", "edad"=>21],
            ["nombre" => " Angela ", "apellidos" => " perez alonso ", "edad"=>32],
        ];

        return $this->render("ejercicio4",
                        [
                            "foto" => $imagenes[$numero],
                            "datos" => $datos[$numero],
        ]);
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
}

views/layouts/main.php
<?php
/** @var yii\web\View $this */

/** @var string $content */
use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);

$this->registerCsrfMetaTags();
$this->registerMetaTag(['charset' => Yii::$app->charset], 'charset');
$this->registerMetaTag(['name' => 'viewport', 'content' => 'width=device-width, initial-scale=1, shrink-to-fit=no']);
$this->registerMetaTag(['name' => 'description', 'content' => $this->params['meta_description'] ?? '']);
$this->registerMetaTag(['name' => 'keywords', 'content' => $this->params['meta_keywords'] ?? '']);
$this->registerLinkTag(['rel' => 'icon', 'type' => 'image/x-icon', 'href' => Yii::getAlias('@web/favicon.ico')]);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
    <head>
        <title><?= Html::encode($this->title) ?></title>
        <?php $this->head() ?>
    </head>
    <body class="d-flex flex-column h-100">
        <?php $this->beginBody() ?>

        <header id="header">
            <?php
            NavBar::begin([
                'brandLabel' => Yii::$app->name,
                'brandUrl' => Yii::$app->homeUrl,
                'options' => ['class' => 'navbar-expand-md navbar-dark bg-dark fixed-top']
            ]);
            echo Nav::widget([
                    'options' => ['class' => 'navbar-nav'],
                    'items' => [
                    ['label' => 'HOME', 'url' => ['/site/index']],
                    ['label' => 'EJERCICIO1', 'url' => ['/site/ejercicio1']],
                    ['label' => 'EJERCICIO2', 'url' => ['/site/ejercicio2']],
                    ['label' => 'EJERCICIO3', 'url' => ['/site/ejercicio3']],
                    ['label'=>'EJERCICIO4','items'=>[
                        ['label'=>'Alumno1','url'=>[
                          '/site/ejercicio4',
                            'numero'=>0,
                        ]],
                        ['label'=>'Alumno2','url'=>[
                          '/site/ejercicio4',
                            'numero'=>1,
                        ]],
                        ['label'=>'Alumno3','url'=>[
                          '/site/ejercicio4',
                            'numero'=>2,
                        ]],
                    ]],    
                 //   ['label' => 'EJERCICIO4-alumno3', 'url' => ['/site/ejercicio4', 'numero' => 2]],
                    ]
                    
                    
            ]);
            NavBar::end();
            ?>
        </header>

        <main id="main" class="flex-shrink-0" role="main">
            <div class="container">
                <?php if (!empty($this->params['breadcrumbs'])): ?>
                    <?= Breadcrumbs::widget(['links' => $this->params['breadcrumbs']]) ?>
                <?php endif ?>
                <?= Alert::widget() ?>
                <?= $content ?>
            </div>
        </main>

        <footer id="footer" class="mt-auto py-3 bg-light">
            <div class="container">
                <div class="row text-muted">
                    <div class="col-md-6 text-center text-md-start">&copy; My Company <?= date('Y') ?></div>
                    <div class="col-md-6 text-center text-md-end"><?= Yii::powered() ?></div>
                </div>
            </div>
        </footer>

        <?php $this->endBody() ?>
    </body>
</html>
<?php $this->endPage() ?>

views/site/ejercicio1.php
<!--<ul>
    <li>Ramon</li>
    <li>Mario</li>
    <li>Denis</li>
    <li>Alberto</li>
    <li>Alalia</li>
    <li>Ana</li>
    <li>Maheva</li>
</ul>-->

<ul>
<?php
use yii\helpers\Html;


foreach ($alumnos as  $alumno) {
    

  ?>   
     <li><?=$alumno?></li>
    <?php     
         
}
 ?>     
   
    
     </ul>

views/site/ejercicio2.php
<?php

use yii\helpers\Html;

echo Html::img("@web/imgs/111.jfif",
        [
            "alt"=>"Responsive image",
            "class"=>"rounded float-left"
            
        ]
    
);
echo Html::img("@web/imgs/222.jfif",
        [
            "alt"=>"Responsive image",
            "class"=>"rounded float-left"
            
        ]
    
);
echo Html::img("@web/imgs/333.jfif",
        [
            "alt"=>"Responsive image",
            "class"=>"rounded float-left"
            
        ]
    
);
echo Html::img("@web/imgs/444.jfif",
        [
            "alt"=>"Responsive image",
            "class"=>"rounded float-left"
            
        ]
    
);

views/site/ejercicio3.php
<?php

use yii\helpers\Html;

echo Html::ul($datos);

views/site/ejercicio4.php
<?php

use yii\helpers\Html;

echo Html::img("@web/imgs/"."{$foto}");

echo $datos["nombre"];

echo Html::tag("li",$datos["nombre"]);
echo Html::tag("li",$datos["apellidos"]);
echo Html::tag("li",$datos["edad"]);

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php



/** @var yii\web\View $this */

$this->title = 'Operaciones';
?>
<h4> 
En un lugar de la Mancha2, de cuyo nombre no quiero acordarme3,
no ha mucho tiempo que vivía un hidalgo de los de lanza en astillero,
adarga antigua, rocín flaco y galgo corredor4. Una olla de algo más vaca que carnero,
salpicón las más noches5, duelos y quebrantos los sábados6, lantejas los viernes7,
algún palomino de añadidura los domingos8, consumían las tres

</h4>